/* cmBac.c was originally generated by the autoSql program, which also 
 * generated cmBac.h and cmBac.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "cmBac.h"

void cmBacStaticLoad(char **row, struct cmBac *ret)
/* Load a row from cmBac table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->acc = row[0];
ret->clone = row[1];
ret->center = row[2];
ret->contig = row[3];
ret->pos = sqlSigned(row[4]);
ret->size = sqlSigned(row[5]);
ret->phase = sqlSigned(row[6]);
}

struct cmBac *cmBacLoad(char **row)
/* Load a cmBac from row fetched with select * from cmBac
 * from database.  Dispose of this with cmBacFree(). */
{
struct cmBac *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->acc = cloneString(row[0]);
ret->clone = cloneString(row[1]);
ret->center = cloneString(row[2]);
ret->contig = cloneString(row[3]);
ret->pos = sqlSigned(row[4]);
ret->size = sqlSigned(row[5]);
ret->phase = sqlSigned(row[6]);
return ret;
}

struct cmBac *cmBacCommaIn(char **pS, struct cmBac *ret)
/* Create a cmBac out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new cmBac */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->acc = sqlStringComma(&s);
ret->clone = sqlStringComma(&s);
ret->center = sqlStringComma(&s);
ret->contig = sqlStringComma(&s);
ret->pos = sqlSignedComma(&s);
ret->size = sqlSignedComma(&s);
ret->phase = sqlSignedComma(&s);
*pS = s;
return ret;
}

void cmBacFree(struct cmBac **pEl)
/* Free a single dynamically allocated cmBac such as created
 * with cmBacLoad(). */
{
struct cmBac *el;

if ((el = *pEl) == NULL) return;
freeMem(el->acc);
freeMem(el->clone);
freeMem(el->center);
freeMem(el->contig);
freez(pEl);
}

void cmBacFreeList(struct cmBac **pList)
/* Free a list of dynamically allocated cmBac's */
{
struct cmBac *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    cmBacFree(&el);
    }
*pList = NULL;
}

void cmBacOutput(struct cmBac *el, FILE *f, char sep, char lastSep) 
/* Print out cmBac.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->acc, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->clone, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->center, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->contig, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->pos, sep);
fputc(sep,f);
fprintf(f, "%d", el->size, sep);
fputc(sep,f);
fprintf(f, "%d", el->phase, lastSep);
fputc(lastSep,f);
}

