/* cmBac.h was originally generated by the autoSql program, which also 
 * generated cmBac.c and cmBac.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef CMBAC_H
#define CMBAC_H

struct cmBac
/* Clone map info for one Bac. */
    {
    struct cmBac *next;  /* Next in singly linked list. */
    char *acc;	/* Genbank accession of BAC */
    char *clone;	/* Roswell Park BAC name */
    char *center;	/* Sequencing center */
    char *contig;	/* Contig name */
    int pos;	/* Relative position of bac in contig in ~kilobase units */
    int size;	/* Size of bac - 0 if unknown */
    int phase;	/* HTC phase of bac - 0 if unknown */
    };

void cmBacStaticLoad(char **row, struct cmBac *ret);
/* Load a row from cmBac table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct cmBac *cmBacLoad(char **row);
/* Load a cmBac from row fetched with select * from cmBac
 * from database.  Dispose of this with cmBacFree(). */

struct cmBac *cmBacCommaIn(char **pS, struct cmBac *ret);
/* Create a cmBac out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new cmBac */

void cmBacFree(struct cmBac **pEl);
/* Free a single dynamically allocated cmBac such as created
 * with cmBacLoad(). */

void cmBacFreeList(struct cmBac **pList);
/* Free a list of dynamically allocated cmBac's */

void cmBacOutput(struct cmBac *el, FILE *f, char sep, char lastSep);
/* Print out cmBac.  Separate fields with sep. Follow last field with lastSep. */

#define cmBacTabOut(el,f) cmBacOutput(el,f,'\t','\n');
/* Print out cmBac as a line in a tab-separated file. */

#define cmBacCommaOut(el,f) cmBacOutput(el,f,',',',');
/* Print out cmBac as a comma separated list including final comma. */

#endif /* CMBAC_H */

