/* hCommon.c - routines used by many files in hgap project. */

#include "common.h"
#include "hCommon.h"

void fragToCloneName(char *fragName, char cloneName[128])
/* Convert fragment name to clone name. */
{
char *e = strchr(fragName, '.');
int size;

if (e == NULL)
    e = fragName + strlen(fragName);
size = e - fragName;
if (size >= 128)
    errAbort("name too long %s\n", fragName);
memcpy(cloneName, fragName, size);
cloneName[size] = 0;
}

void faRecNameToFaFileName(char *dir, char *faName, char *fileName)
/* Convert fa record name to file name. */
{
char *e;
char *d = fileName;
int size;


/* Start file name with directory if any. */
if (dir != NULL)
    {
    size = strlen(dir);
    memcpy(d, dir, size);
    d += size;
    if (dir[size-1] != '/')
	*d++ = '/';
    }
if (*faName == '>')
    ++faName;
faName = skipLeadingSpaces(faName);
e = strchr(faName, '.');
if (e == NULL)
    e = skipToSpaces(faName);
if (e == NULL)
    e = faName + strlen(faName);
size = e - faName;
memcpy(d, faName, size);
d += size;
strcpy(d, ".fa");
}

